--Memory Card Game

without type_check
without warning

include graphics.e
include image.e
include mouse.e
include file.e

constant FACE_UP = 0
constant FACE_DOWN = 1
constant DISCARDED = 2

integer junk
junk = graphics_mode(18)

--Load Graphics
sequence cards, temp, bitmaps
cards = {}
temp = {}
bitmaps = {"cardback.bmp","card1.bmp","card2.bmp","card3.bmp","card4.bmp","card5.bmp","card6.bmp","card7.bmp","card8.bmp","card9.bmp","blank.bmp"}

for i = 1 to length(bitmaps) do
    temp = read_bitmap(current_dir() & "\\" & bitmaps[i])
    cards = append(cards, temp[2])
end for

--Shuffle cards
sequence layout, status, numbers
layout = repeat({}, 3)  --Which cards where
status = repeat({}, 3)  --Face up or face down
numbers = {2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10} --All possible pairs
temp = {}

--Shuffling
for i = 1 to length(layout) do
    for j = 1 to 6 do
        junk = rand(length(numbers))
        layout[i] &= numbers[junk]
        temp = numbers[1..junk-1]
        numbers = numbers[junk+1..length(numbers)]
        temp &= numbers
        numbers = temp
        temp = {}
    end for
end for

status = repeat(repeat(FACE_DOWN, 6), 3) --Lay all cards face down

--Set coordinates of cards
sequence card_coors
integer a, pairs, amount
card_coors = {{},{},{}}
a = 1
pairs = 9
amount = 0

for y = 4 to 480-145 by 145 do
    for x = 7 to 640-105 by 105 do
        card_coors[a] = append(card_coors[a], {x,y})
    end for
    a += 1
end for

object mouse
sequence cardA, cardB
mouse = -1
cardA = {}
cardB = {}

--Draw the screen
procedure draw_screen()
    integer i
    i = 1
        mouse_pointer(0)
        for y = 1 to 3 do
            for x = 1 to 6 do
                if status[y][x] = FACE_DOWN then
                    display_image(card_coors[y][x], cards[status[y][x]])
                elsif status[y][x] = FACE_UP then
                    display_image(card_coors[y][x], cards[layout[y][x]])
                end if
                i+=1
            end for
        end for
        mouse_pointer(1)

        position(29,1)
        text_color(15)
        printf(1,"PAIRS LEFT: %d",{pairs})
        position(29,48)
        text_color(2)
        puts(1, "|   Written by David Stanger  |")
        position(30,1)
        text_color(15)
        printf(1, "TRIES: %d", {amount})
        position(30,48)
        text_color(13)
        puts(1, "|Art work by Beverely Thompson|")
end procedure

procedure pause(atom a)
    atom t
    t = time()
    
    tick_rate(100)

    while t + a > time() do
    end while
    
end procedure

clear_screen()

for i = 8 to 539 by 105 do
    display_image({i,5}, cards[1])
    display_image({i,335}, cards[1])
end for

position(11,18)
puts(1, "Welcome to the Memory Game!")
position(13,18)
puts(1, "To play is simple: Flip the cards over by")
position(14,18)
puts(1, "LEFT clicking on them")
position(15,18)
puts(1, "and try to find matching pairs.")
position(16,18)
puts(1, "You can leave the game at any time by")
position(17,18)
puts(1, "RIGHT clicking.")
position(20,18)
puts(1, "When you are ready to begin press ENTER...")
junk = getc(0)

clear_screen()
draw_screen()

--Main Program Loop
while 1 do
    mouse = get_mouse()
        if sequence(mouse) then
        
            --Right click to exit
            if mouse[1] = RIGHT_UP then
                abort(0)
            end if

            --Left clicks
            if mouse[1] = LEFT_UP or mouse[1] = LEFT_UP + MOVE then
                for i = 1 to 3 do
                    for j = 1 to 6 do
                        if mouse[2] >= card_coors[i][j][1] and mouse[2] <= card_coors[i][j][1]+100 and status[i][j] != DISCARDED then
                            if mouse[3] >= card_coors[i][j][2] and mouse[3] <= card_coors[i][j][2]+140 and status[i][j] != DISCARDED then
                            
                                --Flip over clicked on cards
                                if status[i][j] = FACE_UP then
                                    status[i][j] = FACE_DOWN
                                elsif status[i][j] = FACE_DOWN then
                                    status[i][j] = FACE_UP
                                end if
                                draw_screen()

                                --Track and compare cards
                                if length(cardA) = 0 then
                                    cardA = {layout[i][j], {i,j}}
                                elsif length(cardA) != 0 and length(cardB) = 0 then
                                    cardB = {layout[i][j], {i,j}}
                                    --prevents double selecting a single card for a match
                                    if compare(cardA,cardB) = 0 then
                                        cardB = {}
                                    end if
                                end if
                            
                                --If two cards have been flipped
                                if length(cardA) != 0 and length(cardB) != 0 then
                                    junk = compare(cardA[1], cardB[1])
                                        --Remove matching pairs
                                        if junk = 0 then
                                            status[cardA[2][1]][cardA[2][2]] = DISCARDED
                                            status[cardB[2][1]][cardB[2][2]] = DISCARDED
                                            pairs -= 1
                                            amount += 1
                                                --End game
                                                if pairs = 0 then
                                                    mouse_pointer(0)
                                                    pause(2)
                                                    clear_screen()
                                                    position(11,18)
                                                    puts(1, "CONGRATULATIONS!")
                                                    position(13,18)
                                                    printf(1, "You matched all 9 pairs in %d tries.", {amount})
                                                    position(14,18)
                                                        if amount = 9 then
                                                            puts(1, "That is a PERFECT score!!!! Lucky!")
                                                        elsif amount >= 10 and amount <= 11 then
                                                            puts(1, "Wow! You have a GREAT memory!")
                                                        elsif amount >= 12 and amount <= 15 then
                                                            puts(1, "Nice work! You have a GOOD memory!")
                                                        elsif amount >= 16 and amount <= 18 then
                                                            puts(1, "Hmm. Not bad. Practice!")
                                                        elsif amount >= 19 and amount <= 21 then
                                                            puts(1, "Not very good. Keep trying!")
                                                        else
                                                            puts(1, "You have the memory power of a goldfish...")
                                                        end if
                                                    position(16,18)
                                                    puts(1, "Press ENTER to exit...")
                                                    junk = getc(0)
                                                    abort(0)
                                                end if
                                            cardA = {}
                                            cardB = {}
                                        --Flip non-matches over again
                                        elsif junk != 0 then
                                            pause(.6)
                                            status[cardA[2][1]][cardA[2][2]] = FACE_DOWN
                                            status[cardB[2][1]][cardB[2][2]] = FACE_DOWN
                                            amount += 1
                                            cardA = {}
                                            cardB = {}
                                        end if
                                end if
                                draw_screen()
                                
                                exit
                            end if
                        end if      
                    end for
                end for
            end if
    end if  
end while